import React, { useState } from 'react';
import { TableRow, TableCell } from "../../../elements/Table";
import { Icon, Box } from "../../../elements";
import { SessionProgressBar } from "../../../../kit/SessionProgressBar";
import { SessionStatus } from "../../../../kit/SessionStatus";
import { useWidgetContext } from '../../context';
import { SessionItemAction } from './SessionItemAction';
import { SessionItemDetails } from './SessionItemDetails';
import { SessionName } from './styles';
import { getReviewers } from './utils';
export var SessionItem = function (_a) {
    var session = _a.session, sme = _a.sme, users = _a.users;
    var _b = useState(false), expanded = _b[0], setExpanded = _b[1];
    var _c = useWidgetContext().provider, selectMe = _c.selectMe, openApp = _c.openApp, selectAppsIds = _c.selectAppsIds;
    var me = selectMe();
    var currentUserId = me.id;
    var katId = selectAppsIds().katId;
    var id = session.id, title = session.title, actions = session.actions, teachingOwnerId = session.teachingOwnerId, conversionOwnerId = session.conversionOwnerId;
    var openSession = function () {
        return openApp(katId, { action: 'open-session', id: id, comments: true });
    };
    var toggleExpanded = function () { return setExpanded(function (exp) { return !exp; }); };
    var reviewers = getReviewers({
        users: users,
        session: session,
        sme: sme,
    });
    var highlighted = Boolean(sme ? teachingOwnerId : conversionOwnerId);
    return (React.createElement(React.Fragment, null,
        React.createElement(TableRow, { onClick: toggleExpanded, selected: expanded, highlighted: highlighted },
            React.createElement(TableCell, { small: true, width: 178 },
                React.createElement(Box, { direction: "row", verticalAlign: "center", height: "3.5em" },
                    React.createElement(Icon, { name: "chevron-right", fitted: true, bordered: true, size: "mini", rotate: expanded }),
                    React.createElement(SessionName, { title: title }, title))),
            React.createElement(TableCell, { small: true, width: 130 },
                React.createElement(SessionProgressBar, { session: session, sme: sme, currentUserId: currentUserId })),
            React.createElement(TableCell, { small: true, paddingX: 0.5, width: 160 },
                React.createElement(SessionStatus, { openApp: openSession, session: session, currentUserId: currentUserId, sme: sme, reviewers: reviewers })),
            React.createElement(TableCell, { small: true, width: 155 },
                React.createElement(SessionItemAction, { actions: actions }))),
        expanded && (React.createElement(TableRow, { selected: true, highlighted: highlighted },
            React.createElement(TableCell, { colSpan: 4 },
                React.createElement(SessionItemDetails, { session: session }))))));
};
